package com.witty.handler;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.witty.util.JrebelUtil.JrebelSign;
import org.eclipse.jetty.server.Request;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

public class JrebelHandler {
    public static void jrebelLeasesHandler(String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setStatus(HttpServletResponse.SC_OK);
        String clientRandomness = request.getParameter("randomness");
        String username = request.getParameter("username");
        String guid = request.getParameter("guid");
	    System.out.println(request.getParameterMap());
        boolean offline = Boolean.parseBoolean(request.getParameter("offline"));
        String validFrom = "null";
        String validUntil = "null";
        if (offline) {
            String clientTime = request.getParameter("clientTime");
            String offlineDays = request.getParameter("offlineDays");
            //long clientTimeUntil = Long.parseLong(clientTime) + Long.parseLong(offlineDays)  * 24 * 60 * 60 * 1000;
            long clientTimeUtil = Long.parseLong(clientTime) + 180L * 24 * 60 * 60 * 1000;
            validFrom = clientTime;
            validUntil = String.valueOf(clientTimeUtil);
        }
        baseRequest.setHandled(true);
        
        String jsonStr = """
        {
            "serverVersion": "3.2.4",
            "serverProtocolVersion": "1.1",
            "serverGuid": "a1b4aea8-b031-4302-b602-670a990272cb",
            "groupType": "managed",
            "id": 1,
            "licenseType": 1,
            "evaluationLicense": false,
            "signature": "OJE9wGg2xncSb+VgnYT+9HGCFaLOk28tneMFhCbpVMKoC/Iq4LuaDKPirBjG4o394/UjCDGgTBpIrzcXNPdVxVr8PnQzpy7ZSToGO8wv/KIWZT9/ba7bDbA8/RZ4B37YkCeXhjaixpmoyz/CIZMnei4q7oWR7DYUOlOcEWDQhiY=",
            "serverRandomness": "H2ulzLlh7E0=",
            "seatPoolType": "standalone",
            "statusCode": "SUCCESS",
            "offline": %s,
            "validFrom": %s,
            "validUntil": %s,
            "company": "Administrator",
            "orderId": "",
            "zeroIds": [
               \s
            ],
            "licenseValidFrom": 1490544001000,
            "licenseValidUntil": 1691839999000
        }
        """;
        jsonStr = String.format(jsonStr, offline, validFrom, validUntil);
	    JSONObject jsonObject = JSON.parseObject(jsonStr);
        if (clientRandomness == null || username == null || guid == null) {
            response.setStatus(HttpServletResponse.SC_FORBIDDEN);
        } else {
            JrebelSign jrebelSign = new JrebelSign();
            jrebelSign.toLeaseCreateJson(clientRandomness, guid, offline, validFrom, validUntil);
            String signature = jrebelSign.getSignature();
            jsonObject.put("signature", signature);
            jsonObject.put("company", username);
            String body = jsonObject.toString();
            response.getWriter().print(body);
        }
    }

    public static void jrebelValidateHandler(String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setStatus(HttpServletResponse.SC_OK);
        baseRequest.setHandled(true);
        String jsonStr = """
		{
		    "serverVersion": "3.2.4",
		    "serverProtocolVersion": "1.1",
		    "serverGuid": "a1b4aea8-b031-4302-b602-670a990272cb",
		    "groupType": "managed",
		    "statusCode": "SUCCESS",
		    "company": "Administrator",
		    "canGetLease": true,
		    "licenseType": 1,
		    "evaluationLicense": false,
		    "seatPoolType": "standalone"
		}
		""";
	    JSONObject jsonObject = JSON.parseObject(jsonStr);
        String body = jsonObject.toString();
        response.getWriter().print(body);
    }

    public static void jrebelLeases1Handler(String target, Request baseRequest, HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("application/json; charset=utf-8");
        response.setStatus(HttpServletResponse.SC_OK);
        String username = request.getParameter("username");
        baseRequest.setHandled(true);
        String jsonStr = """
		{
		    "serverVersion": "3.2.4",
		    "serverProtocolVersion": "1.1",
		    "serverGuid": "a1b4aea8-b031-4302-b602-670a990272cb",
		    "groupType": "managed",
		    "statusCode": "SUCCESS",
		    "msg": null,
		    "statusMessage": null
		}
		""";
	    JSONObject jsonObject = JSON.parseObject(jsonStr);
        if (username != null) {
            jsonObject.put("company", username);
        }
        String body = jsonObject.toString();
        response.getWriter().print(body);

    }
}
